import { convertDBSchemasToDBI } from '../types';
import { Pretify, Plurial } from '../../utils';
import { PipelineStage, Model as MongooseModel } from 'mongoose';
import { AggI } from './interface';
export declare class Aggregate<SchemasI extends Record<string, any>, ModelName extends keyof SchemasI & string, DBI = Pretify<convertDBSchemasToDBI<SchemasI>>, ModelI = DBI[Plurial<Lowercase<ModelName>> & keyof DBI]> implements AggI<SchemasI, ModelName> {
    private mongoModel;
    private pipe;
    constructor(mongoModel?: MongooseModel<ModelI>, pipe?: PipelineStage[]);
    /**
     * Returns the current pipeline
     */
    pipeline: AggI<SchemasI, ModelName>['pipeline'];
    project: AggI<SchemasI, ModelName>['project'];
    match: AggI<SchemasI, ModelName>['match'];
    unset: AggI<SchemasI, ModelName>['unset'];
    sort: AggI<SchemasI, ModelName>['sort'];
    limit: AggI<SchemasI, ModelName>['limit'];
    unwind: AggI<SchemasI, ModelName>['unwind'];
    count: AggI<SchemasI, ModelName>['count'];
    lookup: AggI<SchemasI, ModelName>['lookup'];
    /**
     * Executes the aggregate pipeline on the currently bound Model
     */
    exec: AggI<SchemasI, ModelName>['exec'];
    /**
     * Executes the aggregate pipeline on the currently bound Model by paginating the results
     *
     * @param1 skip
     * @param2 limit
     */
    paginate: AggI<SchemasI, ModelName>['paginate'];
    countExec: AggI<SchemasI, ModelName>['countExec'];
}
//# sourceMappingURL=index.d.ts.map