import { BridgeModelI } from './interface';
import { convertDBSchemasToDBI } from './types';
import { Pretify, Plurial } from '../utils';
import { Model as MongooseModel } from 'mongoose';
import { Aggregate } from './aggregate';
import { Schema as SchemaClass } from '../schema';
export declare class BridgeModel<SchemasI extends Record<string, any>, ModelName extends keyof SchemasI & string, DBI = Pretify<convertDBSchemasToDBI<SchemasI>>, Schema extends SchemaClass<any, any> = SchemasI[ModelName], ModelI = DBI[Plurial<Lowercase<ModelName>> & keyof DBI]> implements BridgeModelI<SchemasI, ModelName> {
    modelName: ModelName;
    mongooseModel: MongooseModel<ModelI>;
    modelInterface: ModelI;
    DBI: DBI;
    constructor(schema: Schema, modelName: ModelName);
    aggregate: () => Aggregate<SchemasI, ModelName, DBI, ModelI>;
    create: BridgeModelI<SchemasI, ModelName>['create'];
    find: BridgeModelI<SchemasI, ModelName>['find'];
    findById: BridgeModelI<SchemasI, ModelName>['findById'];
    findOne: BridgeModelI<SchemasI, ModelName>['findOne'];
    findOneAndUpdate: BridgeModelI<SchemasI, ModelName>['findOneAndUpdate'];
    findByIdAndUpdate: BridgeModelI<SchemasI, ModelName>['findByIdAndUpdate'];
    findOneAndDelete: BridgeModelI<SchemasI, ModelName>['findOneAndDelete'];
    findByIdAndDelete: BridgeModelI<SchemasI, ModelName>['findByIdAndDelete'];
    exists: BridgeModelI<SchemasI, ModelName>['exists'];
    countDocuments: BridgeModelI<SchemasI, ModelName>['countDocuments'];
}
export * from './types';
//# sourceMappingURL=index.d.ts.map